﻿using System.Net;
using System.Threading.Tasks;
using System.Web.Mvc;
using AsyncProject.Models;

namespace AsyncProject.Controllers
{
    public class HomeController : AsyncController
    {
        public void IndexAsync()
        {
            AsyncManager.OutstandingOperations.Increment(2);

            Task.Factory.StartNew(() =>
                                      {
                                          // Perform some expensive operation
                                          string uri = "http://www.deanhume.com";

                                          WebClient client = new WebClient();
                                          string reply = client.DownloadString(uri);

                                          AsyncManager.Parameters["data"] = reply;
                                          AsyncManager.OutstandingOperations.Decrement();
                                      });
            Task.Factory.StartNew(() =>
                                      {
                                          // Perform another expensive operation
                                          string uri = "http://www.deanhume.com/home/about";

                                          WebClient client = new WebClient();
                                          string reply = client.DownloadString(uri);

                                          AsyncManager.Parameters["moredata"] = reply;
                                          AsyncManager.OutstandingOperations.Decrement();
                                      });
        }

        public ActionResult IndexCompleted(string data, string moredata)
        {
            Operations translations = new Operations {FirstOperation = data, SecondOperation = moredata};

            return View(translations);
        }
    }
}
